<?php
/**
 * 微信接口
 * @author xianliezhao@foxmail.com
 */
class Data_WeixinAction extends BaseAction{

	public function execute($_matches = array()){
		parent::execute($_matches);
		
		// 微信公众平台接口验证时候用，验证通过以后，就需要把这句代码注释掉，开启下面的代码
		// $this->valid();

		// 处理用户发来的消息
        // 只有验证通过了才把这句代码打开
		$this->responseMsg();
	}

	/**
	 * 验证网站接入
	 * @return [type]
	 */
	public function valid() {
		//define your token
		define("TOKEN", "baidufe");

        $echoStr = $_GET["echostr"];

        //valid signature , option
        if($this->checkSignature()){
        	echo $echoStr;
        	exit;
        }
    }

    /**
     * 在这个方法里，我可以做很多事情
     * @see http://mp.weixin.qq.com/cgi-bin/indexpage?t=wxm-callbackapi-doc&lang=zh_CN
     * @return [type]
     */
    public function responseMsg() {
		//get post data, May be due to the different environments
		$postStr = $GLOBALS["HTTP_RAW_POST_DATA"];

      	//extract post data
		if (!empty($postStr)){
			header('Content-type: text/xml');
            $postObj = simplexml_load_string($postStr, 'SimpleXMLElement', LIBXML_NOCDATA);

            $keyword = trim($postObj->Content);
            // 根据用户发送的内容来进行判断，自动给用户一些反馈信息
            if(empty($keyword)) {
                $this->responseText($postObj);
            }else{
          		$this->responseNews($postObj);
            }

        }else {
        	echo "Alien tell you,sth error...";
        }
    }

    /**
     * 回复文字类型的文字
     * @param  [type] $postObj [description]
     * @return [type]
     */
    private function responseText($postObj){
        $fromUsername = $postObj->FromUserName;
        $toUsername = $postObj->ToUserName;
        $keyword = trim($postObj->Content);

        // 从数据库查询数据
        $respContent = '亲，你输入的内容是空的哦！';

        $this->assign('tWxInfo',array(
                'from' => $fromUsername,
                'to' => $toUsername,
                'time' => time(),
                'type' => 'text',
                'content' => $respContent,
                'flag' => '0'
            ));
        $this->setTpl('data/data_weixin_text.html');
    }

    /**
     * 回复图文类型的文章
     * @param  [type] $postObj [description]
     * @return [type]
     */
    private function responseNews($postObj){
        $fromUsername = $postObj->FromUserName;
        $toUsername = $postObj->ToUserName;
        $keyword = trim($postObj->Content);
        $keyword = trim($postObj->Content);

        // 从数据库查询数据
        $tDatas = $this->searchFromDB($keyword);
        $articles = null;

        if(!empty($tDatas)) {
            // 试着从摘要中提取图片
            $reg = '/<img\s+.*src=([\'\"])\s*(http\:\/\/www.baidufe.com\/[^\'\"]*)\s*\1\s+/ies';
            $picItemIndex = -1;
            foreach ($tDatas as $key => $data) {
                $picUrl = '';
                $digest = $data['digest'];
                $m = preg_match($reg, $digest,$matches);
                if($m) {
                    $picUrl = $matches[2];
                    $picItemIndex = $key;
                }
                $digest = strip_tags($digest);
                $digest = empty($digest) ? $data['title'] : $digest;
                $articles[] = array(
                    'title' => $data['title'],
                    'desc' => $digest,
                    'picUrl' => $picUrl,
                    'url' => 'http://www.baidufe.com/item/' . $data['id'] . '.html'
                );
            }
            // 经过这么一轮折腾，再把有图片的一个放到最前面来
            // 如果没有图片，则来一张默认的
            if($picItemIndex === -1) {
                $picUrl = 'http://www.baidufe.com/fe/static/img/baidufe-title.png';
                $articles[0]['picUrl'] = $picUrl;
            }else{
                // 检测一下第一个节点是否有图片，如果没有，还需要调整一下顺序
                if(!$articles[0]['picUrl']) {
                    $temp = $articles[$picItemIndex];
                    $articles[$picItemIndex] = $articles[0];
                    $articles[0] = $temp;
                }
            }
        }else{
            // 没有找到匹配的内容
            $articles = $this->notFound($keyword);
        }

        $this->assign('tWxInfo',array(
        		'from' => $fromUsername,
        		'to' => $toUsername,
        		'time' => time(),
        		'type' => 'text',
        		'content' => '',  // 图文类型的消息，content可以为空
        		'articles' => $articles,
        		'flag' => '0'
        	));
		$this->setTpl('data/data_weixin_news.html');
    }

    /**
     * 没有检索到数据
     * @return [type]
     */
    private function notFound($keyword){
        $articles = array(
                array(
                        'title' => 'Sorry，没有找到与“' . $keyword . '”匹配的数据',
                        'desc' => '悲了个催的，主人还没有发表过与您搜索的内容相关的文章，你可以到baidufe去看看别的文章！',
                        'picUrl' => 'http://www.baidufe.com/fe/static/img/omg.jpg',
                        'url' => 'http://www.baidufe.com'
                    ),
            );
        return $articles;
    }

    /**
     * 查询内容
     * @param  string $text [description]
     * @return [type]
     */
    private function searchFromDB($text = ''){
        // 创建Service
        $service = $this->createService();
        //初始化，获得数据库链接情况
        $dbStatus = $service->init();

        // 待查找的标签名
        $text = mysql_real_escape_string($text);

        // 本页数据----------------------------------------------------------------
        // 从mysql配置文件中读取sql语句
        $sql = $service->getSql('select_blog_fulltext');
        $sql_list = str_replace(
            array('#text#','#status#','#limit_start#','#limit_end#'),
            array($text,'0',0,5) , // 最多查询5条
            $sql);
        // 查询
        $resBlogData = $service->select($sql_list);
        $tBlogDatas = $resBlogData['data'];

        return $tBlogDatas;
    }
	
	/**
	 * 网站接入用
	 * @return [type]
	 */
	private function checkSignature() {
        $signature = $_GET["signature"];
        $timestamp = $_GET["timestamp"];
        $nonce = $_GET["nonce"];	
        		
		$token = TOKEN;
		$tmpArr = array($token, $timestamp, $nonce);
		sort($tmpArr);
		$tmpStr = implode( $tmpArr );
		$tmpStr = sha1( $tmpStr );
		
		if( $tmpStr == $signature ){
			return true;
		}else{
			return false;
		}
	}	
}